/**
 * This script defines the About LCX view. This view contains three sub pages,
 * the first cover page, the second apply card page and the third map page.
 */
// @formatter:off
/**
 * Author: $Author: herbert $
 * URL: $HeadURL: svn+ssh://192.168.1.54/var/svn/LCX/Resources/ui/common/AboutLCXView.js $
 * Revision: $Id: AboutLCXView.js 144 2013-03-15 08:56:05Z herbert $
 */
// @formatter:on
function AboutLCXView() {
    /*
     * Variable declarations.
     */
    var LANGUAGE_EN = 1;
    var LANGUAGE_TC = 2;

    var language = Ti.App.Properties.getString('language') == "english" ? LANGUAGE_EN : LANGUAGE_TC;

    var platformWidth = Titanium.Platform.displayCaps.platformWidth < Titanium.Platform.displayCaps.platformHeight ? Titanium.Platform.displayCaps.platformWidth : Titanium.Platform.displayCaps.platformHeight;
    var platformHeight = Titanium.Platform.displayCaps.platformWidth > Titanium.Platform.displayCaps.platformHeight ? Titanium.Platform.displayCaps.platformWidth : Titanium.Platform.displayCaps.platformHeight;
    var widthRatio = platformWidth / 640.0;
    var heightRatio = platformHeight / 960.0;
    var smallRatio = widthRatio < heightRatio ? widthRatio : heightRatio;
    var bigRatio = widthRatio > heightRatio ? widthRatio : heightRatio;
    var fontSize = platformHeight / 40;

    /*
     * Text declarations.
     */
    var beOurCardHolderText = {
        english_text : 'Be Our Card Holder',
        chinese_text : '請即申請成為會員'
    };

    var locationMapText = {
        english_text : 'Location Map [Tsimshatsui]',
        chinese_text : '地圖 〔尖沙咀〕'
    };

    var descriptionText = {
        english_text : 'LCX is Hong Kong’s foremost fashion store, complementing its vibrant mix of cutting edge brands, as well as the many complementary and arty happenings hosted. Combining harbour view eateries with hip fashion and accessories, stylish beauty and lifestyle chic, LCX delivers a premium brand concept to the customer, creating an unparalleled shopping experience.\n\nLevel 3 Ocean Terminal, Harbour City, Tsimshatsui',
        chinese_text : '香港著名時裝百貨公司，城中尖端名牌林立，配合各式各樣富藝術氣息的多元化演出，絕對是一個集活力、時尚和藝術於一身的流行地標。眾多領導潮流的時裝、飾物、美容及展現別緻生活方式的商舖匯聚一堂，結合多間可以讓你飽覽維港景色的餐廳，LCX致力為顧客創造的不只是一個前所未有、嶄新的購物體驗，更深層次是一個優質品牌的概念。\n\n九龍尖沙咀海運大廈三階'
    };

    var lcxPhone = '3102 3668';
    var telText = {
        english_text : 'Tel:\t\t' + lcxPhone,
        chinese_text : '電話：\t' + lcxPhone
    };

    var lcxURL = 'http://www.lcx.com.hk';
    var urlText = {
        english_text : 'Web:\t' + lcxURL,
        chinese_text : '網址：\t' + lcxURL
    };

    var titleText = {
        english_text : 'LIMITED EDITION \nLCX x Yum Yum Rewards Card\nAct Now!',
        chinese_text : 'LCX X Yum Yum 獎賞咭\n獨享潮流熱選優惠獎賞\n立刻申請'
    };

    var applyDescriptionText = {
        english_text : 'Be our Cardholder!\nSpend HK$3,000 or more in a day or HK$5,000 or more within a month at LCX and submit the application form to our Customer Service Counter to get your LCX Rewards Card.\n\nLCX Rewards Card offers you\n1) Exclusive Shopping Privilege\n\n2) Bonus Point\nWhen you shopping at LCX,\n- Spending of HK$1 = 1 point\n- Food & beverage / service spending of HK$5 = 1 point:\n\n3) Points Redemption\n- 10,000 points = HK$100 LCX cash coupon\n- 5,000 points = HK$50 LCX cash coupon\n\nWhat’s more, other gift items will be ready for redemption from time to time.\n\nOffer is while stock lasts, first come first served!\nAll terms and conditions apply.\nPlease contact Customer Service Counter staff for details.',
        chinese_text : 'LCX奬賞咭申請方法\n於LCX即日消費滿港幣$3,000或以上或於1個月內在LCX累積消費滿港幣$5,000或以上，並填妥申請表格，交回LCX顧客服務中心即可申請LCX奬賞咭會籍。\n\nLCX奬賞咭專享\n1) 商戶優惠\n於LCX內逾70間參與商戶消費時出示LCX奬賞咭，即可尊享折扣優惠或精選禮品。\n\n2) 積分獎賞\n即日消費金額可兌換為積分︰\n-每消費港幣$1可兌換1分\n-餐飲/服務每消費港幣$5可兌換1分\n\n3) 兌換獎賞\n-10,000分可兌換LCX HK$150禮券\n-5,000分可兌換LCX HK$50禮券\n\n尚有其他精選禮品可供兌換，詳情請留意日後公佈。\n\n禮品數量有限，換完即止。\n所有優惠及奬賞須受有關條款約束及。\n詳情請與LCX顧客服務部職員查詢。'
    };

    /*
     * Construct this object.
     */
    var self = Titanium.UI.createView({
        top : 15 * smallRatio,
        left : 15 * smallRatio,
        right : 15 * smallRatio,
        bottom : 0 * smallRatio,
        visible : false,
        backgroundImage : '/images/back_popup.png'
    });

    /*
     * Prepare the GUI.
     */
    var aboutLCXPane = Ti.UI.createScrollableView({
        scrollingEnabled : false
    });
    self.add(aboutLCXPane);

    var aboutLCXIntro = Ti.UI.createView({
        layout : 'vertical'
    });
    aboutLCXPane.addView(aboutLCXIntro);

    var applyCard = Ti.UI.createLabel({
        width : platformWidth - 80 * smallRatio,
        height : 50 * smallRatio,
        borderRadius : 10 * smallRatio,
        color : 'white',
        font : {
            fontWeight : 'bold',
            fontSize : fontSize
        },
        textAlign : Ti.UI.TEXT_ALIGNMENT_LEFT
    });
    aboutLCXIntro.add(applyCard);

    var locationMap = Ti.UI.createLabel({
        top : 5 * smallRatio,
        bottom : 5 * smallRatio,
        width : platformWidth - 80 * smallRatio,
        height : 50 * smallRatio,
        color : 'white',
        font : {
            fontWeight : 'bold',
            fontSize : fontSize
        },
        textAlign : Ti.UI.TEXT_ALIGNMENT_LEFT
    });
    aboutLCXIntro.add(locationMap);

    var image = Ti.UI.createImageView({
        width : platformWidth - 160 * smallRatio,
        borderWidth : 5 * smallRatio,
        image : '/images/store_tst.png'
    });
    aboutLCXIntro.add(image);

    var descriptionScrollPane = Ti.UI.createScrollView({
        width : platformWidth - 80 * smallRatio,
        layout : 'vertical'
    });
    aboutLCXIntro.add(descriptionScrollPane);

    var description = Ti.UI.createLabel({
        left : 10 * smallRatio,
        right : 10 * smallRatio,
        color : 'white',
        font : {
            fontSize : fontSize
        }
    });
    descriptionScrollPane.add(description);

    var tel = Ti.UI.createLabel({
        left : 10 * smallRatio,
        right : 10 * smallRatio,
        height : 'auto',
        color : 'white',
        font : {
            fontSize : fontSize
        }
    });
    descriptionScrollPane.add(tel);

    var url = Ti.UI.createLabel({
        left : 10 * smallRatio,
        right : 10 * smallRatio,
        height : 'auto',
        color : 'white',
        font : {
            fontSize : fontSize
        }
    });
    descriptionScrollPane.add(url);

    var aboutLCXDetailView = Ti.UI.createView({
        width : 'auto',
        height : 'auto'
    });
    aboutLCXPane.addView(aboutLCXDetailView);

    var aboutLCXDetailPage = Ti.UI.createView({
        left : 15 * smallRatio,
        top : 15 * smallRatio,
        right : 15 * smallRatio,
        bottom : 15 * smallRatio,
        backgroundImage : '/images/back_popup.png'
    });
    aboutLCXDetailView.add(aboutLCXDetailPage);

    aboutLCXDetailPane = Ti.UI.createScrollView({
        top : 10 * smallRatio,
        left : 10 * smallRatio,
        right : 10 * smallRatio,
        bottom : 45 * smallRatio,
        width : 'auto',
        height : 'auto',
        layout : 'vertical'
    });
    aboutLCXDetailPage.add(aboutLCXDetailPane);

    var title = Ti.UI.createLabel({
        top : 5 * smallRatio,
        bottom : 5 * smallRatio,
        textAlign : Titanium.UI.TEXT_ALIGNMENT_CENTER,
        height : Ti.UI.SIZE,
        color : 'white',
        font : {
            fontSize : fontSize
        }
    });
    var image = Ti.UI.createImageView({
        top : 5 * smallRatio,
        bottom : 5 * smallRatio,
        width : 340 * smallRatio,
        height : Ti.UI.SIZE,
        image : '/images/card_reward.png'
    });
    var applyDescription = Ti.UI.createLabel({
        top : 5 * smallRatio,
        bottom : 5 * smallRatio,
        width : platformWidth - 80 * smallRatio,
        height : Ti.UI.SIZE,
        color : 'white',
        font : {
            fontSize : fontSize
        }
    });
    aboutLCXDetailPane.add(title);
    aboutLCXDetailPane.add(image);
    aboutLCXDetailPane.add(applyDescription);

    var buttonPanel = Ti.UI.createView({
        width : Ti.UI.FILL,
        height : 50 * smallRatio,
        bottom : 0
    });
    aboutLCXDetailPage.add(buttonPanel);

    var applyCardFacebook = Ti.UI.createImageView({
        top : 5 * smallRatio,
        left : 10 * widthRatio,
        width : 116 * smallRatio,
        height : 40 * smallRatio,
        image : (language == LANGUAGE_EN ? '/images/btn_facebook.png' : '/images/btn_facebook_tc.png')
    });
    var applyCardEmail = Ti.UI.createImageView({
        top : 7 * smallRatio,
        left : 150 * widthRatio,
        width : 36 * smallRatio,
        height : 35 * smallRatio,
        image : '/images/btn_email.png'
    });
    var applyCardBack = Ti.UI.createImageView({
        top : 2 * smallRatio,
        right : 10 * widthRatio,
        width : 120 * smallRatio,
        height : 45 * smallRatio,
        image : (language == LANGUAGE_EN ? '/images/btn_back.png' : '/images/btn_back_tc.png')
    });

    buttonPanel.add(applyCardFacebook);
    buttonPanel.add(applyCardEmail);
    buttonPanel.add(applyCardBack);

    var aboutLCXMap = Ti.UI.createView();
    aboutLCXPane.addView(aboutLCXMap);

    var annotation = Titanium.Map.createAnnotation({
        title : 'LCX Tsim Sha Tsui‎',
        subtitle : 'Canton Road Hong Kong',
        latitude : 22.295053,
        longitude : 114.165823,
        image : '/images/LCX_75x75.png',
        animate : true
    });
    var lcxMap = Ti.Map.createView({
        left : 15 * smallRatio,
        top : 15 * smallRatio,
        right : 15 * smallRatio,
        bottom : 50 * smallRatio,
        animate : true,
        regionFit : true,
        userLocation : true,
        region : {
            latitude : 22.295053,
            longitude : 114.165823,
            latitudeDelta : 0.009927,
            longitudeDelta : 0.019269
        },
        annotations : [annotation]
    });
    aboutLCXMap.add(lcxMap);

    var mapButtonPanel = Ti.UI.createView({
        width : platformWidth - 80 * smallRatio,
        height : 45 * smallRatio,
        left : 10 * smallRatio,
        right : 10 * smallRatio,
        bottom : 0
    });
    aboutLCXMap.add(mapButtonPanel);

    var mapBack = Ti.UI.createImageView({
        top : 0,
        right : 10 * smallRatio,
        width : 120 * smallRatio,
        height : 45 * smallRatio,
        image : (language == LANGUAGE_EN ? '/images/btn_back.png' : '/images/btn_back_tc.png')
    });
    mapButtonPanel.add(mapBack);

    /*
     * Default operations to be performed after the GUI is built.
     */
    updateText(language);

    /*
     * Private function to be invoked by the same object.
     */
    function updateText(lang) {
        language = lang;
        applyCard.text = (language == LANGUAGE_EN) ? beOurCardHolderText.english_text : beOurCardHolderText.chinese_text;
        locationMap.text = (language == LANGUAGE_EN) ? locationMapText.english_text : locationMapText.chinese_text;
        description.text = (language == LANGUAGE_EN) ? descriptionText.english_text : descriptionText.chinese_text;
        tel.text = (language == LANGUAGE_EN) ? telText.english_text : telText.chinese_text;
        url.text = (language == LANGUAGE_EN) ? urlText.english_text : urlText.chinese_text;
        title.text = (language == LANGUAGE_EN) ? titleText.english_text : titleText.chinese_text;
        applyDescription.text = (language == LANGUAGE_EN) ? applyDescriptionText.english_text : applyDescriptionText.chinese_text;
    }

    /*
     * Event handlers
     */

    /*
     * If the apply card image is clicked, switch to the apply card page.
     */
    applyCard.addEventListener('click', function(e) {
        aboutLCXPane.setCurrentPage(1);
    });

    /*
     * If the map image is cliced, switch to the map page.
     */
    locationMap.addEventListener('click', function(e) {
        aboutLCXPane.setCurrentPage(2);
    });

    /*
     * If the phone number of the shop is clicked, start the default application
     * to handle the phone number, which will start a dialer to make the phone
     * call.
     */
    tel.addEventListener('click', function(e) {
        Titanium.Platform.openURL('tel:' + lcxPhone);
    });

    /*
     * If the URL of the shop is clicked, start the default application to handle
     * the link.
     */
    url.addEventListener('click', function(e) {
        Titanium.Platform.openURL(lcxURL);
    });

    /*
     * If the back image on the apply card page is clicked, switch to the first
     * introduction page.
     */
    applyCardBack.addEventListener('click', function(e) {
        aboutLCXPane.setCurrentPage(0);
    });

    /*
     * If the facebook share image is cliced, post an item on the end user's
     * facebook wall with the built-in facebook module.
     */
    applyCardFacebook.addEventListener('click', function(e) {
        var fb = require('facebook');
        fb.appid = '187761737927481';
        fb.permissions = ["user_checkins", "friends_checkins", "publish_checkins", "read_stream", "offline_access", "publish_stream"];
        fb.authorize();

        var data = {
            link : "http://www.facebook.com/lcxhk",
            name : language == LANGUAGE_EN ? "Recommend a LCX promotion to you" : '推薦你此 LCX 最新推廣',
            caption : title.text,
            picture : "http://lcx.itehk.com.hk/lcxapp/upload/other/card_reward.png",
            description : applyDescription.text
        };
        fb.dialog("feed", data, function(e) {
        });
    });

    /*
     * If the send email image is clicked, compose an email and open the email
     * dialog. As a result, the device will prompt the user to choose his/her
     * preferred application to send the email.
     */
    applyCardEmail.addEventListener('click', function(e) {
        var emailDialog = Ti.UI.createEmailDialog();
        emailDialog.subject = language == LANGUAGE_EN ? "Recommend a LCX promotion to you" : '推薦你此 LCX 最新推廣';
        emailDialog.toRecipients = [];
        emailDialog.messageBody = applyDescription.text;
        emailDialog.addAttachment(Ti.Filesystem.getFile(image.image));
        emailDialog.open();
    });

    /*
     * If the back button on the map page is clicked, switch to the first
     * introduction page.
     */
    mapBack.addEventListener('click', function(e) {
        aboutLCXPane.setCurrentPage(0);
    });

    /*
     * Public function.
     */

    /*
     * Update the language of this GUI.
     */
    self.updateLanguage = function() {
        language = Ti.App.Properties.getString('language') == "english" ? LANGUAGE_EN : LANGUAGE_TC;
        updateText(language);
        applyCardFacebook.image = (language == LANGUAGE_EN ? '/images/btn_facebook.png' : '/images/btn_facebook_tc.png');
        applyCardBack.image = (language == LANGUAGE_EN ? '/images/btn_back.png' : '/images/btn_back_tc.png');
        mapBack.image = (language == LANGUAGE_EN ? '/images/btn_back.png' : '/images/btn_back_tc.png');
    };

    return self;
};

module.exports = AboutLCXView;
