/**
 * The class definition of MapWindow. It defines the window with a map and a Back
 * button.
 */
// @formatter:off
/**
 * Author: $Author: herbert $
 * URL: $HeadURL: svn+ssh://192.168.1.54/var/svn/LCX/Resources/ui/common/MapWindow.js $
 * Revision: $Id: MapWindow.js 125 2013-03-07 13:41:57Z herbert $
 */
// @formatter:on
function MapWindow() {
    /*
    * Variable declaration.
    */

    // Get the screen width
    var platformWidth = Titanium.Platform.displayCaps.platformWidth < Titanium.Platform.displayCaps.platformHeight ? Titanium.Platform.displayCaps.platformWidth : Titanium.Platform.displayCaps.platformHeight;

    var LANGUAGE_EN = 1;
    var LANGUAGE_TC = 2;

    var language = Ti.App.Properties.getString('language') == "english" ? LANGUAGE_EN : LANGUAGE_TC;

    /*
     * Create this object.
     */
    var self = Ti.UI.createWindow({
        width : platformWidth,
        navBarHidden : true,
        fullscreen : true,
        visible : false,
        layout : 'vertical'
    });

    /*
     * Create the GUI.
     */
    var mapPane = Ti.UI.createScrollView({
        top : 0,
        left : 0,
        right : 0,
        bottom : 50
    });
    self.add(mapPane);

    var imgMap = Ti.UI.createImageView({
        width : platformWidth,
        height : 'auto',
    });
    mapPane.add(imgMap);

    var buttonPane = Ti.UI.createView({
        top : 0,
        left : 0,
        right : 0,
        bottom : 0
    });
    self.add(buttonPane);

    var imgBack = Ti.UI.createImageView({
        top : 0,
        left : platformWidth - 150,
        image : (language == LANGUAGE_EN ? '/images/btn_back.png' : '/images/btn_back_tc.png')
    });
    buttonPane.add(imgBack);

    /*
     * Add event handler.
     */
    imgBack.addEventListener('click', function(e) {
        self.close();
    });

    /*
     * Define public methods.
     */

    /*
     * Update this object based on the specified object, in particular the URL of
     * the map.
     */
    self.updateLocation = function(objs) {
        imgMap.image = 'http://lcx.itehk.com.hk/lcxapp/upload/location/' + encodeURIComponent(objs.location[0].map_image);
    };
    /*
     * Update the language to be used by this object.
     */
    self.updateLanguage = function() {
        language = Ti.App.Properties.getString('language') == "english" ? LANGUAGE_EN : LANGUAGE_TC;
        imgBack.image = language == LANGUAGE_EN ? '/images/btn_back.png' : '/images/btn_back_tc.png';
    };

    return self;
}

module.exports = MapWindow;
