/**
 * This defines the What's On View.
 */

// @formatter:off
/**
 * Author: $Author: herbert $
 * URL: $HeadURL: svn+ssh://192.168.1.54/var/svn/LCX/Resources/ui/common/WhatsOnView.js $
 * Revision: $Id: WhatsOnView.js 125 2013-03-07 13:41:57Z herbert $
 */
// @formatter:on
function WhatsOnView() {
    /*
    * Variable declarations.
    */

    // Section to be shown
    var WHATS_HOT = 1;
    var WHATS_NEW = 2;
    var contentType = WHATS_HOT;

    // For Language setting
    var LANGUAGE_EN = 1;
    var LANGUAGE_TC = 2;
    var language = Ti.App.Properties.getString('language') == "english" ? LANGUAGE_EN : LANGUAGE_TC;

    // Get the screen width
    var platformWidth = Titanium.Platform.displayCaps.platformWidth < Titanium.Platform.displayCaps.platformHeight ? Titanium.Platform.displayCaps.platformWidth : Titanium.Platform.displayCaps.platformHeight;
    var platformHeight = Titanium.Platform.displayCaps.platformWidth > Titanium.Platform.displayCaps.platformHeight ? Titanium.Platform.displayCaps.platformWidth : Titanium.Platform.displayCaps.platformHeight;
    var widthRatio = platformWidth / 640.0;
    var heightRatio = platformHeight / 960.0;
    var smallRatio = widthRatio < heightRatio ? widthRatio : heightRatio;
    var bigRatio = widthRatio > heightRatio ? widthRatio : heightRatio;
    var fontSize = platformHeight / 40;

    // Other variable for storing current object
    var runningObj = null;
    var currentIndex;
    var currentRow;

    /*
     * Variables for storing the row objects for different sections and
     * languages.
     */
    var engWhatsHot = [];
    var engWhatsNew = [];
    var chnWhatsHot = [];
    var chnWhatsNew = [];

    /*
     * Set up the layout of this view.
     */
    var self = Ti.UI.createView({
        width : Titanium.UI.FILL,
        height : Titanium.UI.FILL,
        layout : 'vertical'
    });

    var runningTextPane = Ti.UI.createView({
        top : 0,
        left : 0,
        right : 0,
        width : platformWidth,
        height : Ti.UI.SIZE
    });
    self.add(runningTextPane);
    var runningText = Ti.UI.createLabel({
        top : 0,
        left : platformWidth - 1,
        right : 0,
        width : platformWidth * 2,
        height : Ti.UI.SIZE,
        font : {
            fontSize : fontSize
        }
    });
    runningTextPane.add(runningText);

    var whatsOnMainPane = Ti.UI.createScrollableView({
        width : Ti.UI.FILL,
        height : Ti.UI.FILL,
        scrollingEnabled : false
    });
    self.add(whatsOnMainPane);

    var whatsOnIndexPane = Ti.UI.createView({
        height : Titanium.UI.FILL,
        layout : 'vertical'
    });
    whatsOnMainPane.addView(whatsOnIndexPane);

    var switchButtonPane = Ti.UI.createView({
        width : Ti.UI.FILL,
        height : 32 * smallRatio,
    });
    whatsOnIndexPane.add(switchButtonPane);

    var btnWhatsHot = Ti.UI.createImageView({
        image : (contentType == WHATS_HOT) ? (language == LANGUAGE_EN ? '/images/title_whatsOn_01b.png' : '/images/title_whatsOn_01b_tc.png') : (language == LANGUAGE_EN ? '/images/title_whatsOn_01a.png' : '/images/title_whatsOn_01a_tc.png'),
        width : 160 * smallRatio,
        height : 32 * smallRatio,
        top : 0,
        left : platformWidth / 4 - 160 * smallRatio / 2
    });
    switchButtonPane.add(btnWhatsHot);
    var btnWhatsNew = Ti.UI.createImageView({
        image : (contentType == WHATS_NEW) ? (language == LANGUAGE_EN ? '/images/title_whatsOn_02b.png' : '/images/title_whatsOn_02b_tc.png') : (language == LANGUAGE_EN ? '/images/title_whatsOn_0ba.png' : '/images/title_whatsOn_02b_tc.png'),
        width : 160 * smallRatio,
        height : 32 * smallRatio,
        top : 0,
        left : platformWidth * 3 / 4 - 160 * smallRatio / 2
    });
//    switchButtonPane.add(btnWhatsNew);

    var whatsOnContentPane = Ti.UI.createView({
        width : 'auto',
        height : 'auto',
        top : 15 * smallRatio,
        left : 15 * smallRatio,
        right : 15 * smallRatio,
        bottom : 15 * smallRatio,
        backgroundImage : '/images/back_popup.png'
    });
    whatsOnIndexPane.add(whatsOnContentPane);

    var table = Ti.UI.createTableView({
        top : 10 * smallRatio,
        left : 10 * smallRatio,
        right : 10 * smallRatio,
        bottom : 10 * smallRatio
    });
    whatsOnContentPane.add(table);

    var whatsOnDetailView = Ti.UI.createView({
        width : Titanium.UI.FILL,
        height : Titanium.UI.FILL
    });
    whatsOnMainPane.addView(whatsOnDetailView);

    var whatsOnDetailPage = Ti.UI.createView({
        left : 15 * smallRatio,
        top : 15 * smallRatio,
        right : 15 * smallRatio,
        bottom : 0 * smallRatio,
        backgroundImage : '/images/back_popup.png'
    });
    whatsOnDetailView.add(whatsOnDetailPage);

    whatsOnDetailPane = Ti.UI.createScrollView({
        top : 10 * smallRatio,
        left : 10 * smallRatio,
        right : 10 * smallRatio,
        bottom : 65 * smallRatio,
        layout : 'vertical'
    });
    whatsOnDetailPage.add(whatsOnDetailPane);

    var title = Ti.UI.createLabel({
        textAlign : Titanium.UI.TEXT_ALIGNMENT_CENTER,
        height : 'auto',
        color : 'white',
        font : {
            fontSize : fontSize
        }
    });
    var image = Ti.UI.createImageView({
        top : 5 * smallRatio,
        width : platformWidth / 2
    });
    var description = Ti.UI.createLabel({
        top : 5 * smallRatio,
        width : platformWidth - 80 * smallRatio,
        height : Ti.UI.SIZE,
        color : 'white',
        font : {
            fontSize : fontSize
        }
    });
    whatsOnDetailPane.add(title);
    whatsOnDetailPane.add(image);
    whatsOnDetailPane.add(description);

    var buttonPanel = Ti.UI.createView({
        width : Ti.UI.FILL,
        height : 65 * smallRatio,
        bottom : 0
    });
    whatsOnDetailPage.add(buttonPanel);

    var imgFacebook = Ti.UI.createImageView({
        top : 5 * smallRatio,
        left : 30 * widthRatio,
        width : 116 * smallRatio,
        height : 40 * smallRatio,
        image : (language == LANGUAGE_EN ? '/images/btn_facebook.png' : '/images/btn_facebook_tc.png')
    });
    var imgEmail = Ti.UI.createImageView({
        top : 7 * smallRatio,
        left : 170 * widthRatio,
        width : 36 * smallRatio,
        height : 35 * smallRatio,
        image : '/images/btn_email.png'
    });
    var imgBack = Ti.UI.createImageView({
        top : 2 * smallRatio,
        right : 30 * widthRatio,
        width : 120 * smallRatio,
        height : 45 * smallRatio,
        image : (language == LANGUAGE_EN ? '/images/btn_back.png' : '/images/btn_back_tc.png')
    });

    buttonPanel.add(imgFacebook);
    buttonPanel.add(imgEmail);
    buttonPanel.add(imgBack);

    table.addEventListener('click', function(e) {
        var row = e.row;
        currentIndex = e.index;
        whatsOnMainPane.setCurrentPage(1);
        title.text = row.detailTitle;
        image.image = row.detailImage;
        description.text = row.detailDescription;
    });

    /*
     * Event handlers.
     */

    /*
     * When the Facebook Share button is clicked, share the item with Facebook
     * module.
     */
    imgFacebook.addEventListener('click', function(e) {
        var fb = require('facebook');
        fb.appid = '187761737927481';
        fb.permissions = ["user_checkins", "friends_checkins", "publish_checkins", "read_stream", "offline_access", "publish_stream"];
        fb.authorize();

        var data = {
            link : "http://www.facebook.com/lcxhk",
            name : language == LANGUAGE_EN ? "Recommend a LCX promotion to you" : '推薦你此 LCX 最新推廣',
            caption : title.text,
            picture : image.image,
            description : description.text
        };
        fb.dialog("feed", data, function(e) {
        });
    });

    /*
     * When the Email button is clicked, prepare an email to be shown in an email
     * dialog.
     */
    imgEmail.addEventListener('click', function(e) {
        var emailDialog = Ti.UI.createEmailDialog();
        emailDialog.subject = language == LANGUAGE_EN ? "Recommend a LCX promotion to you" : '推薦你此 LCX 最新推廣';
        emailDialog.toRecipients = [];
        emailDialog.messageBody = description.text;

        var httpClient = Titanium.Network.createHTTPClient();
        httpClient.setTimeout(10000);
        httpClient.onload = function(e) {
            emailDialog.addAttachment(this.responseData);
            emailDialog.open();
        };
        httpClient.onerror = function(e) {
            emailDialog.open();
        };
        httpClient.open('GET', image.image);
        httpClient.send();
    });

    /*
     * If the Back button is clicked, return to the index page.
     */
    imgBack.addEventListener('click', function(e) {
        whatsOnMainPane.setCurrentPage(0);
    });

    /*
     * If the What's Hot button is clicked, set the index to be for What's Hot.
     */
    btnWhatsHot.addEventListener('click', function(e) {
        setContentType(WHATS_HOT);
    });

    /*
     * If the What's New button is clicked, set the index to be for What's New.
     */
    btnWhatsNew.addEventListener('click', function(e) {
        setContentType(WHATS_NEW);
    });

    /*
     * Public functions.
     */

    /*
     * Set the content type.
     */
    function setContentType(ct) {
        contentType = ct;
        btnWhatsHot.image = (contentType == WHATS_HOT) ? (language == LANGUAGE_EN ? '/images/title_whatsOn_01b.png' : '/images/title_whatsOn_01b_tc.png') : (language == LANGUAGE_EN ? '/images/title_whatsOn_01a.png' : '/images/title_whatsOn_01a_tc.png');
        btnWhatsNew.image = (contentType == WHATS_NEW) ? (language == LANGUAGE_EN ? '/images/title_whatsOn_02b.png' : '/images/title_whatsOn_02b_tc.png') : (language == LANGUAGE_EN ? '/images/title_whatsOn_02a.png' : '/images/title_whatsOn_02a_tc.png');
        var data = (language == LANGUAGE_EN) ? (contentType == WHATS_HOT ? engWhatsHot : engWhatsNew) : (contentType == WHATS_HOT ? chnWhatsHot : chnWhatsNew);
        table.setData(data);
        currentRow = data[currentIndex];
        table.scrollToTop(0);
    }

    /*
     * Update the running text according to the specified object.
     */
    self.updateRunningText = function(objs) {
        runningObj = objs.running[0];
        runningText.text = (language == LANGUAGE_EN) ? objs.running[0].content_english : objs.running[0].content_chinese;
        self.startAnimation();
    };

    /*
     * Update the rows for the two sections and two languages according to the
     * specified object.
     */
    self.updatePromotions = function(objs) {
        for (var i = 0; i < objs.promotion.length; i++) {
            if (objs.promotion[i].section == "What's Hot") {
                var row = Ti.UI.createTableViewRow();
                row.detailTitle = objs.promotion[i].header_english;
                row.detailImage = 'http://lcx.itehk.com.hk/lcxapp/upload/promotion/' + encodeURIComponent(objs.promotion[i].image_1);
                row.detailDescription = objs.promotion[i].content_english;
                row.add(Ti.UI.createImageView({
                    image : 'http://lcx.itehk.com.hk/lcxapp/upload/promotion/' + encodeURIComponent(objs.promotion[i].thumbnail_image),
                    top : 40 * smallRatio,
                    left : 40 * smallRatio,
                    width : 128 * smallRatio,
                    height : 200 * smallRatio,
                    clickName : 'image'
                }));
                row.add(Ti.UI.createLabel({
                    top : 40 * smallRatio,
                    left : 180 * smallRatio,
                    right : 40 * smallRatio,
                    bottom : 0,
                    width : 'auto',
                    height : 200 * smallRatio,
                    ellipsize : true,
                    clickName : 'text',
                    verticalAlign : Titanium.UI.TEXT_VERTICAL_ALIGNMENT_TOP,
                    text : objs.promotion[i].content_english,
                    font : {
                        fontSize : fontSize
                    }
                }));
                engWhatsHot.push(row);

                row = Ti.UI.createTableViewRow();
                row.detailTitle = objs.promotion[i].header_chinese;
                row.detailImage = 'http://lcx.itehk.com.hk/lcxapp/upload/promotion/' + encodeURIComponent(objs.promotion[i].image_1);
                row.detailDescription = objs.promotion[i].content_chinese;
                row.add(Ti.UI.createImageView({
                    image : 'http://lcx.itehk.com.hk/lcxapp/upload/promotion/' + encodeURIComponent(objs.promotion[i].thumbnail_image),
                    top : 40 * smallRatio,
                    left : 40 * smallRatio,
                    width : 128 * smallRatio,
                    height : 200 * smallRatio,
                    clickName : 'image'
                }));
                row.add(Ti.UI.createLabel({
                    top : 40 * smallRatio,
                    left : 208 * smallRatio,
                    right : 40 * smallRatio,
                    bottom : 0,
                    width : 'auto',
                    height : 200 * smallRatio,
                    ellipsize : true,
                    clickName : 'text',
                    verticalAlign : Titanium.UI.TEXT_VERTICAL_ALIGNMENT_TOP,
                    text : objs.promotion[i].content_chinese,
                    font : {
                        fontSize : fontSize
                    }
                }));
                chnWhatsHot.push(row);
            } else {
                var row = Ti.UI.createTableViewRow();
                row.detailTitle = objs.promotion[i].header_english;
                row.detailImage = 'http://lcx.itehk.com.hk/lcxapp/upload/promotion/' + encodeURIComponent(objs.promotion[i].image_1);
                row.detailDescription = objs.promotion[i].content_english;
                row.add(Ti.UI.createImageView({
                    image : 'http://lcx.itehk.com.hk/lcxapp/upload/promotion/' + encodeURIComponent(objs.promotion[i].thumbnail_image),
                    top : 40 * smallRatio,
                    left : 40 * smallRatio,
                    width : 128 * smallRatio,
                    height : 200 * smallRatio,
                    clickName : 'image'
                }));
                row.add(Ti.UI.createLabel({
                    top : 40 * smallRatio,
                    left : 208 * smallRatio,
                    right : 40 * smallRatio,
                    bottom : 0,
                    width : 'auto',
                    height : 200 * smallRatio,
                    ellipsize : true,
                    clickName : 'text',
                    verticalAlign : Titanium.UI.TEXT_VERTICAL_ALIGNMENT_TOP,
                    text : objs.promotion[i].content_english,
                    font : {
                        fontSize : fontSize
                    }
                }));
                engWhatsNew.push(row);

                row = Ti.UI.createTableViewRow();
                row.detailTitle = objs.promotion[i].header_chinese;
                row.detailImage = 'http://lcx.itehk.com.hk/lcxapp/upload/promotion/' + encodeURIComponent(objs.promotion[i].image_1);
                row.detailDescription = objs.promotion[i].content_chinese;
                row.add(Ti.UI.createImageView({
                    image : 'http://lcx.itehk.com.hk/lcxapp/upload/promotion/' + encodeURIComponent(objs.promotion[i].thumbnail_image),
                    top : 40,
                    left : 40,
                    width : 128 * smallRatio,
                    height : 200 * smallRatio,
                    clickName : 'image'
                }));
                row.add(Ti.UI.createLabel({
                    top : 40 * smallRatio,
                    left : 208 * smallRatio,
                    right : 40 * smallRatio,
                    bottom : 0,
                    width : 'auto',
                    height : 200 * smallRatio,
                    ellipsize : true,
                    clickName : 'text',
                    verticalAlign : Titanium.UI.TEXT_VERTICAL_ALIGNMENT_TOP,
                    text : objs.promotion[i].content_chinese,
                    font : {
                        fontSize : fontSize
                    }
                }));
                chnWhatsNew.push(row);
            }
        }

        setContentType(contentType);
    };

    /*
     * Set the language of this view.
     */
    self.updateLanguage = function() {
        language = Ti.App.Properties.getString('language') == "english" ? LANGUAGE_EN : LANGUAGE_TC;
        btnWhatsHot.image = (contentType == WHATS_HOT) ? (language == LANGUAGE_EN ? '/images/title_whatsOn_01b.png' : '/images/title_whatsOn_01b_tc.png') : (language == LANGUAGE_EN ? '/images/title_whatsOn_01a.png' : '/images/title_whatsOn_01a_tc.png');
        btnWhatsNew.image = (contentType == WHATS_NEW) ? (language == LANGUAGE_EN ? '/images/title_whatsOn_02b.png' : '/images/title_whatsOn_02b_tc.png') : (language == LANGUAGE_EN ? '/images/title_whatsOn_0ba.png' : '/images/title_whatsOn_02b_tc.png');
        imgFacebook.image = (language == LANGUAGE_EN ? '/images/btn_facebook.png' : '/images/btn_facebook_tc.png');
        imgBack.image = (language == LANGUAGE_EN ? '/images/btn_back.png' : '/images/btn_back_tc.png');
        if (runningObj != null) {
            runningText.text = (language == LANGUAGE_EN) ? runningObj.content_english : runningObj.content_chinese;
        }
        setContentType(contentType);
        whatsOnMainPane.setCurrentPage(0);
    };

    /*
     * Stop the running text animation.
     */
    var animating = false;
    var timerId = 0;
    self.stopAnimation = function() {
        if (timerId != 0) {
            clearInterval(timerId);
        }
        runningText.animate(Ti.UI.createAnimation({
            left : platformWidth - 1,
            duration : 1
        }));
    };

    /*
     * Start the running text animation.
     */
    self.animateRunningText = function() {
        runningText.animate(Ti.UI.createAnimation({
            left : -platformWidth,
            duration : 10000
        }), function() {
            runningText.animate(Ti.UI.createAnimation({
                left : platformWidth - 1,
                duration : 1
            }));
        });
    };
    self.startAnimation = function() {
        animating = true;
        self.animateRunningText();
        timerId = setInterval(self.animateRunningText, 10000);
    };

    return self;
};

module.exports = WhatsOnView;
